/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2009 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.python.editor.options;

import org.netbeans.modules.options.editor.spi.PreferencesCustomizer;
import static org.netbeans.modules.python.editor.options.FmtOptions.*;
import static org.netbeans.modules.python.editor.options.FmtOptions.CategorySupport.OPTION_ID;

/**
 * Options related to imports
 * 
 * @author  Tor Norbye
 */
public class FmtImports extends javax.swing.JPanel {
    
    /** Creates new form FmtImports */
    public FmtImports() {
        initComponents();

        formatImportsCb.putClientProperty(OPTION_ID, formatImports);
        onePerLineCb.putClientProperty(OPTION_ID, oneImportPerLine);
        removeDuplicateCb.putClientProperty(OPTION_ID, removeDuplicates);
        systemLibsCb.putClientProperty(OPTION_ID, systemLibsFirst);
        cleanupCombo.putClientProperty(OPTION_ID, cleanupUnusedImports);
        preferSymbols.putClientProperty(OPTION_ID, preferSymbolImports);
        sortImportsCb.putClientProperty(OPTION_ID, sortImports);
        sepFromImpCb.putClientProperty(OPTION_ID, separateFromImps);
    }
    
    public static PreferencesCustomizer.Factory getController() {
        return new CategorySupport.Factory("imports", FmtImports.class,
                org.openide.util.NbBundle.getMessage(FmtImports.class, "SAMPLE_Imports"));
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        formatImportsCb = new javax.swing.JCheckBox();
        onePerLineCb = new javax.swing.JCheckBox();
        systemLibsCb = new javax.swing.JCheckBox();
        removeDuplicateCb = new javax.swing.JCheckBox();
        cleanupLabel = new javax.swing.JLabel();
        cleanupCombo = new javax.swing.JComboBox();
        preferSymbols = new javax.swing.JCheckBox();
        sortImportsCb = new javax.swing.JCheckBox();
        sepFromImpCb = new javax.swing.JCheckBox();

        setName(org.openide.util.NbBundle.getMessage(FmtImports.class, "LBL_Imports")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(formatImportsCb, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.formatImportsCb.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(onePerLineCb, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.onePerLineCb.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(systemLibsCb, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.systemLibsCb.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(removeDuplicateCb, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.removeDuplicateCb.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(cleanupLabel, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.cleanupLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(preferSymbols, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.preferSymbols.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(sortImportsCb, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.sortImportsCb.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(sepFromImpCb, org.openide.util.NbBundle.getMessage(FmtImports.class, "FmtImports.sepFromImpCb.text")); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(formatImportsCb)
                    .add(onePerLineCb)
                    .add(systemLibsCb)
                    .add(sortImportsCb)
                    .add(sepFromImpCb)
                    .add(removeDuplicateCb)
                    .add(preferSymbols)
                    .add(layout.createSequentialGroup()
                        .add(cleanupLabel)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(cleanupCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(formatImportsCb)
                .add(18, 18, 18)
                .add(onePerLineCb)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(systemLibsCb)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(sortImportsCb)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(sepFromImpCb)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(removeDuplicateCb)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(preferSymbols)
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cleanupLabel)
                    .add(cleanupCombo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox cleanupCombo;
    private javax.swing.JLabel cleanupLabel;
    private javax.swing.JCheckBox formatImportsCb;
    private javax.swing.JCheckBox onePerLineCb;
    private javax.swing.JCheckBox preferSymbols;
    private javax.swing.JCheckBox removeDuplicateCb;
    private javax.swing.JCheckBox sepFromImpCb;
    private javax.swing.JCheckBox sortImportsCb;
    private javax.swing.JCheckBox systemLibsCb;
    // End of variables declaration//GEN-END:variables
    
}
