/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * ExistingPythonProjectPanelVisual.java
 *
 * Created on Sep 12, 2008, 8:06:29 AM
 */

package org.netbeans.modules.python.project.templates;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.netbeans.spi.project.ui.support.ProjectChooser;
import org.openide.WizardDescriptor;
import org.openide.WizardValidationException;
import org.openide.filesystems.FileUtil;
import org.openide.util.NbBundle;

/**
 *
 * @author Tomas Zezula
 */
class ExistingPythonProjectPanelVisual extends SettingsPanel implements DocumentListener {

    private PanelConfigureProject panel;

    /** Creates new form ExistingPythonProjectPanelVisual */
    public ExistingPythonProjectPanelVisual(final PanelConfigureProject panel) {
        assert panel != null;
        this.panel = panel;
        initComponents();
        postInitComponents();
    }
    
    private void postInitComponents () {
        this.projectFolder.getDocument().addDocumentListener(this);
        this.projectName.getDocument().addDocumentListener(this);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        projectName = new javax.swing.JTextField();
        projectFolder = new javax.swing.JTextField();
        browse = new javax.swing.JButton();

        jLabel1.setLabelFor(projectName);
        org.openide.awt.Mnemonics.setLocalizedText(jLabel1, org.openide.util.NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ExistingPythonProjectPanelVisual.projectName.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(jLabel2, org.openide.util.NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ExistingPythonProjectPanelVisual.projectFolder.text")); // NOI18N

        projectName.setText(org.openide.util.NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ExistingPythonProjectPanelVisual.projectName.text")); // NOI18N

        projectFolder.setText(org.openide.util.NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ExistingPythonProjectPanelVisual.projectFolder.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(browse, org.openide.util.NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ExistingPythonProjectPanelVisual.browse.text")); // NOI18N
        browse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseAction(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel2)
                    .add(jLabel1))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(projectFolder, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 167, Short.MAX_VALUE)
                        .add(1, 1, 1)
                        .add(browse)
                        .add(48, 48, 48))
                    .add(projectName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(projectName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(projectFolder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(browse))
                .addContainerGap(29, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void browseAction(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseAction
        JFileChooser chooser = new JFileChooser();
        FileUtil.preventFileChooserSymlinkTraversal(chooser, null);
        chooser.setDialogTitle(NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "LBL_SelectProjectFolder"));
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        String path = this.projectFolder.getText();
        if (path.length() > 0) {
            File f = new File(path);
            if (f.exists()) {
                chooser.setSelectedFile(f);
            }
        }
        if (JFileChooser.APPROVE_OPTION == chooser.showOpenDialog(this)) {
            File projectDir = chooser.getSelectedFile();
            projectFolder.setText(FileUtil.normalizeFile(projectDir).getAbsolutePath());
        }
        panel.fireChangeEvent();
    }//GEN-LAST:event_browseAction


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browse;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField projectFolder;
    private javax.swing.JTextField projectName;
    // End of variables declaration//GEN-END:variables

    @Override
    void store(WizardDescriptor settings) {
        assert  settings != null;
        String name = projectName.getText().trim();
        String folder = projectFolder.getText().trim();
        settings.putProperty(NewPythonProjectWizardIterator.PROP_PROJECT_LOCATION, FileUtil.normalizeFile(new File(folder)));
        settings.putProperty(NewPythonProjectWizardIterator.PROP_PROJECT_NAME, name);
    }

    @Override
    void read(WizardDescriptor settings) {
        File projectLocation = (File) settings.getProperty(NewPythonProjectWizardIterator.PROP_PROJECT_LOCATION);
        String defaultName = null;
        if (projectLocation == null || projectLocation.getParentFile() == null || !projectLocation.getParentFile().isDirectory()) {
            defaultName = NewPythonProjectWizardIterator.getFreeFolderName(ProjectChooser.getProjectsFolder(), "NewPythonProject");     //NOI18N
            projectLocation = new File (ProjectChooser.getProjectsFolder(),defaultName);
        }
        this.projectFolder.setText(projectLocation.getAbsolutePath());

        String projectName = (String) settings.getProperty(NewPythonProjectWizardIterator.PROP_PROJECT_NAME);
        if (projectName == null) {
            assert defaultName != null;
            projectName = defaultName;
        }
        this.projectName.setText(projectName);
        this.projectName.selectAll();
    }

    @Override
    boolean valid(WizardDescriptor settings) {
        if (projectName.getText().length() == 0) {
            settings.putProperty("WizardPanel_errorMessage",
                    NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ERR_WrongName"));
            return false; // Display name not specified
        }
        File f = FileUtil.normalizeFile(new File(projectFolder.getText()).getAbsoluteFile());
        if (f.exists() && !f.isDirectory()) {
            String message = NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ERR_WrongProjectFolder");
            settings.putProperty("WizardPanel_errorMessage", message);
            return false;
        }

        if (f.exists() && !f.canWrite()) {
            settings.putProperty("WizardPanel_errorMessage",
                    NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ERR_ReadOnlyProjectFolder"));
            return false;
        }

        if (f.exists() && FileUtil.toFileObject(f) == null) {
            String message = NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ERR_WrongProjectFolder");
            settings.putProperty("WizardPanel_errorMessage", message);
            return false;
        }

        File[] kids = f.listFiles();
        if (kids != null) {
            for (File kid : kids) {
                if ("nbproject".equals(kid.getName())) {    //NOI18N
                    settings.putProperty("WizardPanel_errorMessage",
                    NbBundle.getMessage(ExistingPythonProjectPanelVisual.class, "ERR_AlreadyAnProject"));
                    return false;
                }
            }
        }
        settings.putProperty("WizardPanel_errorMessage", "");   //NOI18N
        return true;
    }

    @Override
    void validate(WizardDescriptor settings) throws WizardValidationException {        
    }

    public void insertUpdate(DocumentEvent e) {
        handleDocChange ();
    }

    public void removeUpdate(DocumentEvent e) {
        handleDocChange ();
    }

    public void changedUpdate(DocumentEvent e) {
        handleDocChange ();
    }
    
    private void handleDocChange () {
        this.panel.fireChangeEvent();
    }

}
